## mingw-w64-aws-c-s3-0.11.5-1.src.tar.zst

=== tests/CMakeLists.txt ===
include(AwsTestHarness)
enable_testing()

option(BYO_CRYPTO "Don't build a tls implementation or link against a crypto interface. This feature is only for unix builds currently." OFF)

if(BYO_CRYPTO)
    set(ENABLE_NET_TESTS OFF)

    add_test_case(test_s3_client_byo_crypto_no_options)
    add_test_case(test_s3_client_byo_crypto_with_options)
endif()

file(GLOB TEST_SRC "*.c")
file(GLOB TEST_HDRS "*.h")
file(GLOB TESTS ${TEST_HDRS} ${TEST_SRC})

add_test_case(test_s3_library_init_cleanup_init_cleanup)
add_test_case(test_s3_copy_http_message)
add_test_case(test_s3_message_util_assign_body)
add_test_case(test_s3_ranged_get_object_message_new)
add_test_case(test_s3_set_multipart_request_path)
add_test_case(test_s3_create_multipart_upload_message_new)
add_test_case(test_s3_upload_part_message_new)
add_test_case(test_s3_upload_part_message_fail)
add_test_case(test_s3_complete_multipart_message_new)
add_test_case(test_s3_abort_multipart_upload_message_new)

add_net_test_case(test_s3_client_create_destroy)
add_net_test_case(test_s3_client_create_error)
add_net_test_case(test_s3_client_create_error_with_invalid_memory_limit_config)
add_net_test_case(test_s3_client_create_error_with_invalid_network_interface)
add_net_test_case(test_s3_client_monitoring_options_override)
add_net_test_case(test_s3_client_proxy_ev_settings_override)
add_net_test_case(test_s3_client_tcp_keep_alive_options_override)
add_net_test_case(test_s3_client_max_active_connections_override)
add_test_case(test_s3_client_get_max_active_connections)
add_net_test_case(s3_meta_request_max_active_connections_override)
add_net_test_case(s3_max_active_connections_override_enforced)
add_test_case(test_s3_request_create_destroy)
add_test_case(test_s3_client_queue_requests)
add_test_case(test_s3_meta_request_body_streaming)
add_test_case(test_s3_update_meta_requests_trigger_prepare)
add_test_case(test_s3_client_update_connections_finish_result)

add_net_test_case(test_s3_client_exceed_retries)
add_net_test_case(test_s3_client_acquire_connection_fail)
add_net_test_case(test_s3_meta_request_fail_prepare_request)
add_net_test_case(test_s3_meta_request_sign_request_fail)
add_net_test_case(test_s3_meta_request_send_request_finish_fail)
add_net_test_case(test_s3_auto_range_put_missing_upload_id)

add_net_test_case(test_s3_cancel_mpu_create_not_sent)
add_net_test_case(test_s3_cancel_mpu_create_completed)
add_net_test_case(test_s3_cancel_mpu_one_part_completed)
add_net_test_case(test_s3_cancel_mpu_one_part_completed_async)
add_net_test_case(test_s3_cancel_mpu_one_part_completed_file_streaming)
add_net_test_case(test_s3_cancel_mpu_all_parts_completed)
add_net_test_case(test_s3_cancel_mpu_cancellable_requests)
add_net_test_case(test_s3_pause_mpu_cancellable_requests)
add_net_test_case(test_s3_cancel_mpd_nothing_sent)
add_net_test_case(test_s3_cancel_mpd_one_part_sent)
add_net_test_case(test_s3_cancel_mpd_one_part_completed)
add_net_test_case(test_s3_cancel_mpd_two_parts_completed)
add_net_test_case(test_s3_cancel_mpd_head_object_sent)
add_net_test_case(test_s3_cancel_mpd_head_object_completed)
add_net_test_case(test_s3_cancel_mpd_empty_object_get_with_part_number_1_sent)
add_net_test_case(test_s3_cancel_mpd_empty_object_get_with_part_number_1_completed)
add_net_test_case(test_s3_cancel_mpd_pending_streaming)
add_net_test_case(test_s3_cancel_prepare)

add_net_test_case(test_s3_get_object_tls_disabled)
add_net_test_case(test_s3_get_object_tls_enabled)
add_net_test_case(test_s3_get_object_tls_default)
add_net_test_case(test_s3_get_object_less_than_part_size)
add_net_test_case(test_s3_get_object_file_path)
add_net_test_case(test_s3_get_object_file_path_create_new)
add_net_test_case(test_s3_get_object_file_path_append)
add_net_test_case(test_s3_get_object_file_path_to_position)
add_net_test_case(test_s3_get_object_empty_object)
add_net_test_case(test_s3_get_object_multiple)
add_net_test_case(test_s3_get_object_multiple_serial)
add_net_test_case(test_s3_get_object_sse_kms)
add_net_test_case(test_s3_get_object_sse_aes256)
add_net_test_case(test_s3_get_object_looks_like_async_error_xml)
add_net_test_case(test_s3_default_get_object_looks_like_async_error_xml)
add_net_test_case(test_s3_get_object_backpressure_small_increments)
add_net_test_case(test_s3_get_object_backpressure_big_increments)
add_net_test_case(test_s3_get_object_backpressure_initial_size_zero)
add_net_test_case(test_s3_get_object_backpressure_small_increments_recv_filepath)
add_net_test_case(test_s3_get_object_backpressure_big_increments_recv_filepath)
add_net_test_case(test_s3_get_object_backpressure_initial_size_zero_recv_filepath)
add_net_test_case(test_s3_get_object_backpressure_small_increments_s3express)
add_net_test_case(test_s3_get_object_backpressure_big_increments_s3express)
add_net_test_case(test_s3_get_object_backpressure_initial_size_s3express)
add_net_test_case(test_s3_get_object_part)
add_net_test_case(test_s3_no_signing)
add_net_test_case(test_s3_signing_override)
add_net_test_case(test_s3_put_object_tls_disabled)
add_net_test_case(test_s3_put_object_tls_enabled)
add_net_test_case(test_s3_put_object_tls_default)
add_net_test_case(test_s3_multipart_put_object_with_acl)
add_net_test_case(test_s3_put_object_multiple)
add_net_test_case(test_s3_put_object_multiple_with_filepath)
add_net_test_case(test_s3_put_object_multiple_with_filepath_streaming)
add_net_test_case(test_s3_put_object_less_than_part_size)
add_net_test_case(test_s3_put_object_less_than_part_size_with_content_encoding)
add_net_test_case(test_s3_put_object_mpu_with_content_encoding)
add_net_test_case(test_s3_put_object_multipart_threshold)
add_net_test_case(test_s3_put_object_multipart_threshold_less_than_part_size)
add_net_test_case(test_s3_put_object_empty_object)
add_net_test_case(test_s3_put_object_with_part_remainder)
add_net_test_case(test_s3_put_object_sse_kms)
add_net_test_case(test_s3_put_object_sse_kms_multipart)
add_net_test_case(test_s3_put_object_sse_aes256)
add_net_test_case(test_s3_put_object_sse_aes256_multipart)
add_net_test_case(test_s3_put_object_sse_c_aes256_multipart)
add_net_test_case(test_s3_put_object_sse_c_aes256_multipart_with_checksum)
add_net_test_case(test_s3_put_object_singlepart_no_content_md5_enabled)
add_net_test_case(test_s3_put_object_singlepart_no_content_md5_disabled)
add_net_test_case(test_s3_put_object_singlepart_correct_content_md5_enabled)
add_net_test_case(test_s3_put_object_singlepart_correct_content_md5_disabled)
add_net_test_case(test_s3_put_object_singlepart_incorrect_content_md5_enabled)
add_net_test_case(test_s3_put_object_singlepart_incorrect_content_md5_disabled)
add_net_test_case(test_s3_put_object_multipart_no_content_md5_enabled)
add_net_test_case(test_s3_put_object_multipart_no_content_md5_disabled)
add_net_test_case(test_s3_put_object_multipart_correct_content_md5_enabled)
add_net_test_case(test_s3_put_object_multipart_correct_content_md5_disabled)
add_net_test_case(test_s3_put_object_multipart_incorrect_content_md5_enabled)
add_net_test_case(test_s3_put_object_multipart_incorrect_content_md5_disabled)
add_net_test_case(test_s3_upload_part_message_with_content_md5)
add_net_test_case(test_s3_upload_part_message_without_content_md5)
add_net_test_case(test_s3_create_multipart_upload_message_with_content_md5)
add_net_test_case(test_s3_complete_multipart_message_with_content_md5)
add_net_test_case(test_s3_put_object_double_slashes)
add_net_test_case(test_s3_put_object_no_content_length)
add_net_test_case(test_s3_put_object_single_part_no_content_length)
add_net_test_case(test_s3_put_object_zero_size_no_content_length)
add_net_test_case(test_s3_put_large_object_no_content_length_with_checksum)
add_net_test_case(test_s3_put_object_no_content_length_multiple)
add_net_test_case(test_s3_put_object_async_singlepart)
add_net_test_case(test_s3_put_object_async_multipart)
add_net_test_case(test_s3_put_object_async_read_completes_synchronously)
add_net_test_case(test_s3_put_object_small_reads)
add_net_test_case(test_s3_put_object_async_small_reads)
add_net_test_case(test_s3_put_object_async_no_content_length_partial_part)
add_net_test_case(test_s3_put_object_async_no_content_length_1part)
add_net_test_case(test_s3_put_object_async_no_content_length_empty_part2)
add_net_test_case(test_s3_put_object_async_no_content_length_2parts)
add_net_test_case(test_s3_put_object_async_fail_reading)
add_net_test_case(test_s3_put_object_if_none_match)
add_net_test_case(test_s3_put_object_mpu_if_none_match)
add_net_test_case(test_s3_many_async_uploads_without_data)
add_net_test_case(test_s3_download_empty_file_with_checksum)
add_net_test_case(test_s3_download_empty_file_with_checksum_header)
add_net_test_case(test_s3_download_single_part_file_with_checksum)
add_net_test_case(test_s3_download_multipart_file_with_checksum)
add_net_test_case(test_s3_asyncwrite_empty_file)
add_net_test_case(test_s3_asyncwrite_small_file_1_write)
add_net_test_case(test_s3_asyncwrite_small_file_1_write_then_eof)
add_net_test_case(test_s3_asyncwrite_small_file_many_writes)
add_net_test_case(test_s3_asyncwrite_1_part)
add_net_test_case(test_s3_asyncwrite_1_part_many_writes)
add_net_test_case(test_s3_asyncwrite_1_part_then_eof)
add_net_test_case(test_s3_asyncwrite_2_parts_2_partsize_writes)
add_net_test_case(test_s3_asyncwrite_2_parts_1_write)
add_net_test_case(test_s3_asyncwrite_2_parts_first_write_over_partsize)
add_net_test_case(test_s3_asyncwrite_2_parts_first_write_under_partsize)
add_net_test_case(test_s3_asyncwrite_tolerate_empty_writes)
add_net_test_case(test_s3_asyncwrite_write_from_future_callback)
add_net_test_case(test_s3_asyncwrite_fails_if_request_has_completed)
add_net_test_case(test_s3_asyncwrite_fails_if_write_after_eof)
add_net_test_case(test_s3_asyncwrite_fails_if_writes_overlap)
add_net_test_case(test_s3_asyncwrite_cancel_sends_abort)

if(ENABLE_MRAP_TESTS)
    add_net_test_case(test_s3_get_object_less_than_part_size_mrap)
    add_net_test_case(test_s3_get_object_multipart_mrap)
    add_net_test_case(test_s3_put_object_less_than_part_size_mrap)
endif()

add_net_test_case(test_s3_round_trip)
add_net_test_case(test_s3_round_trip_default_get)
add_net_test_case(test_s3_round_trip_multipart_get_fc)
add_net_test_case(test_s3_round_trip_default_get_fc)
add_net_test_case(test_s3_round_trip_empty_fc)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_fc)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_with_list_algorithm_fc)
add_net_test_case(test_s3_round_trip_mpu_default_get_fc)
add_net_test_case(test_s3_round_trip_default_get_fc_header)
add_net_test_case(test_s3_round_trip_multipart_get_fc_header)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_fc_header)
add_net_test_case(test_s3_round_trip_with_filepath)
add_net_test_case(test_s3_round_trip_mpu_with_filepath)
add_net_test_case(test_s3_round_trip_with_filepath_no_content_length)
add_net_test_case(test_s3_round_trip_mpu_with_filepath_no_content_length)
add_net_test_case(test_s3_round_trip_mpu_with_filepath_streaming)
add_net_test_case(test_s3_round_trip_mpu_with_filepath_no_content_length_streaming)
add_net_test_case(test_s3_round_trip_mpu_with_filepath_streaming_full_object_checksum_header)
add_net_test_case(test_s3_round_trip_mpu_with_filepath_streaming_full_object_checksum_via_callback)
add_net_test_case(test_s3_mpu_with_filepath_streaming_dont_support_parts_checksum_via_header)
add_net_test_case(test_s3_round_trip_default_get_full_object_checksum_fc)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_full_object_checksum_fc)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_full_object_checksum_fc_header)
add_net_test_case(test_s3_round_trip_mpu_multipart_get_full_object_checksum_via_callback)
add_net_test_case(test_s3_round_trip_dynamic_range_size_download_multipart)
add_net_test_case(test_s3_round_trip_dynamic_range_size_download_multipart_with_buffer_pool_optimize)
add_net_test_case(test_s3_round_trip_dynamic_range_size_download_single_part)
add_net_test_case(test_s3_chunked_then_unchunked)

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=aws-c-s3
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.11.5
pkgrel=1
pkgdesc='C99 library implementation for communicating with the S3 service, designed for maximizing throughput on high bandwidth EC2 instances (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/awslabs/aws-c-s3'
msys2_references=(
  'archlinux: aws-c-s3'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-aws-c-common"
         "${MINGW_PACKAGE_PREFIX}-aws-c-auth"
         "${MINGW_PACKAGE_PREFIX}-aws-checksums")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/awslabs/aws-c-s3/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('bc76ad6e4ef40703477cd2e411553b85216def71a0073cfe8b7fad8d3728b37c')

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  CFLAGS+=" -Wno-format" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_PREFIX_PATH=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=OFF \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./

  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  CFLAGS+=" -Wno-format" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_PREFIX_PATH=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_TESTING=OFF \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build ./
}

check() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"

  cd "${srcdir}/build-${MSYSTEM}-shared"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  PATH=$PWD:$PATH ${MINGW_PREFIX}/bin/ctest.exe ./ || warning "Tests failed"
}

package() {
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install ./

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
